org.cpsolver.studentsct.heuristics.selection

## Class RndUnProblStudSelection

- java.lang.Object
- - org.cpsolver.studentsct.heuristics.selection.RandomUnassignmentSelection
  - - org.cpsolver.studentsct.heuristics.selection.RndUnProblStudSelection

- All Implemented Interfaces:
    NeighbourSelection<Request,Enrollment>

      public class RndUnProblStudSelection
      extends RandomUnassignmentSelection

  Random unassignment of some problematic students. Problematic students are to be provided by a neighbour selection that was used before this one by `RoundRobinNeighbourSelection`.
  In each step a problematic student is randomly selected with the given probabilty. Null is returned otherwise (the controll is passed to the next `NeighbourSelection`).
  Parameters:

  Related Solver Parameters
  Parameter | Type | Comment
  --- | --- | ---
  Neighbour.RandomUnassignmentOfProblemStudentProb | `Double` | Probability of a random selection of a student from the given set of problematic students.

  Version:
    StudentSct 1.3 (Student Sectioning)
    Copyright (C) 2007 - 2014 Tomáš Müller
    muller@unitime.org
    http://muller.unitime.org
    This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.
    This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
    You should have received a copy of the GNU Lesser General Public License along with this library; if not see http://www.gnu.org/licenses/.
  Author:
    Tomáš Müller

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.cpsolver.studentsct.heuristics.selection.RandomUnassignmentSelection

      `RandomUnassignmentSelection.UnassignStudentNeighbour`

  - ### Field Summary

    - ### Fields inherited from class org.cpsolver.studentsct.heuristics.selection.RandomUnassignmentSelection

      `iRandom`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `RndUnProblStudSelection(DataProperties properties, ProblemStudentsProvider psp)` Constructor

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `init(Solver<Request,Enrollment> solver)` Initialization -- `ProblemStudentsProvider.getProblemStudents()` is called
    `Neighbour<Request,Enrollment>` | `selectNeighbour(Solution<Request,Enrollment> solution)` With the given probabilty, a problematic student is randomly selected to be unassigned.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### RndUnProblStudSelection

          public RndUnProblStudSelection(DataProperties properties,
                                         ProblemStudentsProvider psp)

      Constructor
      Parameters:
        `properties` - configuration
        `psp` - a class that provides the set of problematic students

  - ### Method Detail

    - #### init

          public void init(Solver<Request,Enrollment> solver)

      Initialization -- `ProblemStudentsProvider.getProblemStudents()` is called
      Specified by:
        `init` in interface `NeighbourSelection<Request,Enrollment>`
      Overrides:
        `init` in class `RandomUnassignmentSelection`
      Parameters:
        `solver` - current solver

    - #### selectNeighbour

          public Neighbour<Request,Enrollment> selectNeighbour(Solution<Request,Enrollment> solution)

      With the given probabilty, a problematic student is randomly selected to be unassigned. Null is returned otherwise.
      Specified by:
        `selectNeighbour` in interface `NeighbourSelection<Request,Enrollment>`
      Overrides:
        `selectNeighbour` in class `RandomUnassignmentSelection`
      Parameters:
        `solution` - given solution
      Returns:
        a neighbour assignment